%global	install_loc			%{_datadir}/eclipse/dropins/wtp-jeetools

%global javaee_tag			201305152300
%global javaee_dir			webtools.javaee-%{javaee_tag}

%global ejb_tag				201305070000
%global ejb_dir				webtools.ejb-%{ejb_tag}

%global	webservices_tag		201304171447
%global	webservices_dir		webtools.webservices-%{webservices_tag}

%global	common_tag			v201305151500
%global	common_dir			webtools.common-%{common_tag}

%global	sourceediting_tag	201305161752
%global	sourceediting_dir	webtools.sourceediting-%{sourceediting_tag}


Name:		eclipse-wtp-jeetools
Version:	3.5.0
Release:	0.1%{?dist}
Summary:	Frameworks and tools focused on development of J2EE artifacts

Group:		Development/Tools
License:	EPL
URL:		http://www.eclipse.org/webtools/jee/

Obsoletes:	eclipse-wtp-jeetools <= 3.4.0-4
Obsoletes:	eclipse-wtp-jst-web <= 3.4.0-2
Provides:	eclipse-wtp-jst-web = %{version}


# Tarball is created using fetch-wtp-jeetools-using-map.sh script
Source0:	http://git.eclipse.org/c/jeetools/webtools.javaee.git/snapshot/%{javaee_dir}.tar.bz2
Source1:	http://git.eclipse.org/c/ejb/webtools.ejb.git/snapshot/%{ejb_dir}.tar.bz2
Source2:	http://git.eclipse.org/c/webservices/webtools.webservices.git/snapshot/%{webservices_dir}.tar.bz2
Source3:	http://git.eclipse.org/c/webtools-common/webtools.common.git/snapshot/%{common_dir}.tar.bz2
Source4:	http://git.eclipse.org/c/sourceediting/webtools.sourceediting.git/snapshot/%{sourceediting_dir}.tar.bz2
Source5:	http://www.eclipse.org/legal/epl-v10.html

Patch3:		%{name}-jem.proxy-fix-getTypeClass-method.patch
Patch4:		%{name}-jst.j2ee.webservice-manifest.patch

# Update name of apache-commons-discovery jar for copying
Patch6:		%{name}-copyaxisjarcommand.patch

# These two patches just remove inclusion of features built in webservices
Patch7:		%{name}-rm-wst.ws_ui-include.patch
Patch8:		%{name}-rm-wst.ws_core-include.patch
Patch9:		%{name}-wst.web.patch

BuildArch:	noarch

BuildRequires:	ant >= 0:1.8.3-1
BuildRequires:	axis >= 0:1.4-14
BuildRequires:	eclipse-dtp >= 1.10-0.1
BuildRequires:	eclipse-emf >= 2.8.0-0.7
BuildRequires:	eclipse-emf-core >= 1:2.8.0-0.22
BuildRequires:	eclipse-gef >= 3.8.0-0.3
BuildRequires:	eclipse-jdt >= 1:4.2.0-0.22
BuildRequires:	eclipse-pde >= 1:4.2.0-0.22
BuildRequires:	eclipse-platform >= 1:4.2.0-0.22
BuildRequires:	eclipse-rcp >= 1:4.2.0-0.22
BuildRequires:	eclipse-swt >= 1:4.2.0-0.22
BuildRequires:	eclipse-wtp-common >= 3.4.2-4
BuildRequires:	eclipse-wtp-servertools >= 3.4.2-2
BuildRequires:	eclipse-wtp-sourceediting >= 3.4.2-2
BuildRequires:	eclipse-wtp-webservices >= 3.4.2-1
BuildRequires:	icu4j-eclipse >= 1:4.4.2.2-11
BuildRequires:	javamail >= 1.4.3-11
BuildRequires:	java-devel
BuildRequires:	jdom >= 0:1.1.3
BuildRequires:	jpackage-utils
BuildRequires:	wsdl4j >= 0:1.6.2-5

Requires:	ant >= 0:1.8.3-1
Requires:	axis >= 0:1.4-14
Requires:	eclipse-dtp >= 1.10-0.1
Requires:	eclipse-emf >= 2.8.0-0.7
Requires:	eclipse-emf-core >= 1:2.8.0-0.22
Requires:	eclipse-gef >= 3.8.0-0.3
Requires:	eclipse-jdt >= 1:4.2.0-0.22
Requires:	eclipse-platform >= 1:4.2.0-0.22
Requires:	eclipse-rcp >= 1:4.2.0-0.22
Requires:	eclipse-swt >= 1:4.2.0-0.22
Requires:	eclipse-wtp-common >= 3.4.2-4
Requires:	eclipse-wtp-servertools >= 3.4.2-2
Requires:	eclipse-wtp-sourceediting >= 3.4.2-2
Requires:	eclipse-wtp-webservices >= 3.4.2-1
Requires:	icu4j-eclipse >= 1:4.4.2.2-11
Requires:	java
Requires:	javamail >= 1.4.3-11
Requires:	jdom >= 0:1.1.3
Requires:	jpackage-utils
Requires:	wsdl4j >= 0:1.6.2-5


%description
The Java EE Tools Project provides frameworks and tools focused on the
development of J2EE artifacts.


%prep
%setup -q -c
%setup -q -T -D -a 1
cp %{SOURCE5} .

# Take missing bundles from other wtp subprojects
tar xfj %{SOURCE2}
pushd %{webservices_dir}
cp -r bundles/org.eclipse.jst.ws.consumption ../
cp -r bundles/org.eclipse.jst.ws.consumption.ui ../
cp -r bundles/org.eclipse.jst.ws.axis.consumption.core ../
cp -r bundles/org.eclipse.jst.ws.axis.consumption.ui ../
cp -r bundles/org.eclipse.jst.ws ../
cp -r bundles/org.eclipse.jst.ws.axis.creation.ui ../
cp -r bundles/org.eclipse.jst.ws.creation.ui ../
cp -r bundles/org.eclipse.jst.ws.ui ../
cp -r bundles/org.eclipse.jst.ws.uddiregistry ../
cp -r bundles/org.eclipse.jst.ws.creation.ejb.ui ../
cp -r bundles/org.eclipse.jst.ws.jaxrs.core ../
cp -r bundles/org.eclipse.jst.ws.jaxrs.ui ../
cp -r docs/org.eclipse.jst.ws.axis.infopop ../
cp -r docs/org.eclipse.jst.ws.axis.ui.doc.user ../
cp -r docs/org.eclipse.jst.ws.consumption.ui.doc.user ../
cp -r docs/org.eclipse.jst.ws.doc.user ../
cp -r docs/org.eclipse.jst.ws.consumption.infopop ../
cp -r docs/org.eclipse.jst.ws.infopop ../
popd
rm -r %{webservices_dir}

tar xfj %{SOURCE3}
pushd %{common_dir}
cp -r plugins/org.eclipse.jst.common.ui/ ../
popd
rm -r %{common_dir}

tar xfj %{SOURCE4}
pushd %{sourceediting_dir}
cp -r docs/org.eclipse.jst.jsp.ui.infopop ../
cp -r bundles/org.eclipse.jst.jsp.core ../
cp -r bundles/org.eclipse.jst.jsp.ui ../
cp -r bundles/org.eclipse.jst.standard.schemas ../
cp -r bundles/org.eclipse.wst.jsdt.web.support.jsp ../
popd
rm -r %{sourceediting_dir}

find . -type f -name *.jar -exec rm -f {} \;
find . -type f -name *.class -exec rm -f {} \;

# build fails looking for old versions of javax.wsdl
find -name MANIFEST.MF -exec sed -i -e \
	"s/javax.wsdl;bundle-version=\"\[1\.5\.0,1\.6\.0)/javax.wsdl;bundle-version=\"\[1\.6\.2,1\.7\.0)/g" {} \;

pushd %{javaee_dir}/features
%patch7
%patch8
%patch9
popd
pushd %{javaee_dir}/plugins
%patch3
%patch4
popd
%patch6

#Orbit links
# not sure if all of these are needed since they're also in wtp-webservices
rm -rf orbit
mkdir orbit
pushd orbit
%{__ln_s} %{_javadir}/jdom.jar
%{__ln_s} %{_javadir}/javamail/dsn.jar
popd

# Remove problematic org.eclipse.license stuff
find -name feature.xml -type f -exec sed -i -e 's/license-feature="org.eclipse.license"//g' {} \;


%build
%{_bindir}/eclipse-pdebuild -f org.eclipse.jst.web_ui.feature \
	-d "eclipse-wtp-common wtp-sourceediting dtp-connectivity dtp-modelbase \
		org.eclipse.jst.server_ui.feature emf" \
	-o `pwd`/orbit

%{_bindir}/eclipse-pdebuild -f org.eclipse.jst.enterprise_ui.feature \
	-d "eclipse-wtp-common wtp-sourceediting dtp-connectivity dtp-modelbase \
		org.eclipse.jst.server_ui.feature wtp-webservices xsd gef emf" \
	-o `pwd`/orbit


%install
install -d -m 755 %{buildroot}%{install_loc}
%{__unzip} -q -d %{buildroot}%{install_loc} \
	build/rpmBuild/org.eclipse.jst.enterprise_ui.feature.zip

%{__unzip} -q -d %{buildroot}%{install_loc} \
	build/rpmBuild/org.eclipse.jst.web_ui.feature.zip

# remove duplicate jars provided by other wtp packages
pushd %{buildroot}%{install_loc}/eclipse/plugins
#rm -f org.eclipse.jst.jsp.ui.infopop_*
rm -f org.eclipse.wst.command.env.ui_*
#putting this back in temporarily, as it causes problems when it's removed
#rm -f org.eclipse.wst.web_*
rm -f org.eclipse.wst.web.ui_*
popd


%files
%{install_loc}
%doc epl-v10.html
%doc %{javaee_dir}/plugins/org.eclipse.jst.jee/about.html

%changelog
* Thu May 23 2013 Gerard Ryan <galileo@fedoraproject.org> - 3.5.0-0.1
- Start building from upstream master branches in anticipation for 3.5.0

* Sun May 12 2013 Gerard Ryan <galileo@fedoraproject.org> 3.4.2-3
- Provide eclipse-wtp-jst-web so that it can be retired

* Mon May 06 2013 Gerard Ryan <galileo@fedoraproject.org> 3.4.2-2
- Add missing bundle org.eclipse.jst.servlet.ui
- Remove unused patch from SRPM

* Sun May 05 2013 Gerard Ryan <galileo@fedoraproject.org> 3.4.2-1
- Update to latest upstream version 3.4.2

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.4.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Jan 09 2013 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-5
- Update NVR to satisfy upgradepath

* Wed Nov 14 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-4
- Fix copying of axis jars: RHBZ 872806

* Sat Jul 21 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-3
- Comment out org.eclipse.wst.web_* removal, to allow building against this

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Fri Jul 13 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-1
- Update to R3.4.0 Juno stable release.
- Remove duplicate jars build by other wtp packages
- Remove extraneous BR/R that were only needed because of wtp-webservices fault

* Fri Jun 22 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-0.2.20120618cvs
- Rename patch files, add versions to BuildRequires/Requires

* Mon Jun 18 2012 Gerard Ryan <galileo@fedoraproject.org> 3.4.0-0.1.20120618cvs
- Initial Fedora package
